#import "Controller.h"
#import "Book.h"
#import <stdio.h>					// for printf, fgets

@implementation Controller


- (BOOL)readFile
{
	id fmanager;
	fmanager = [NSFileManager defaultManager];
	if ([fmanager fileExistsAtPath:bookFile]) {
		books = [NSKeyedUnarchiver unarchiveObjectWithFile:bookFile];
		return YES;
	} else {
		return NO;
	}

}

- (id)init
{
	NSString *home;
	self = [super init];
	if (self != nil) {
		home = NSHomeDirectory();
		bookFile = [home stringByAppendingString:@"/Library/Preferences/AABook.dat"];
		if (![self readFile])
			
			books = [NSMutableArray array];
	}
	return self;
}


- (BOOL)isRegistered
{
	if ([books count]) {
		return YES;
	} else {
		printf("何も登録がありません。\n");
		return NO;
	}
}

- (void)showAllBook
{
	if ([self isRegistered]) {
		for (Book *book in books) {
			[self showBook:book];
		}
	}
}

- (void)showSpecifiedBook
{
	char ss[MAXLENGTH];
	BOOL exist;
	if ([self isRegistered]) {
		printf("お名前は:");
		fgets(ss, MAXLENGTH, stdin);
		exist = NO;
		for (Book *book in books) {
			if ([[book name] isEqualToString:[NSString	stringWithUTF8String:ss]]) {
				[self showBook:book];
				exist = YES;
			}
		}
		if (! exist) {
			printf("お名前が見つかりませんでした。\n");
		}
	}
}

- (void)showBook:(Book *)book
{
	puts("------------------------------");
	
	printf("%s", [[book name] cStringUsingEncoding:NSUTF8StringEncoding]);
	printf("%s", [[book address] cStringUsingEncoding:NSUTF8StringEncoding]);
	printf("%s", [[book phone] cStringUsingEncoding:NSUTF8StringEncoding]);
	printf("%s", [[book email] cStringUsingEncoding:NSUTF8StringEncoding]);
}

- (void)addBook
{
	Book *book = [[Book alloc] init];
	char ss[MAXLENGTH];
	int i;
	BOOL insert;
	
	printf("氏　　名:");
	fgets(ss, MAXLENGTH, stdin);
	[book setName:[NSString stringWithUTF8String:ss]];
	printf("住　　所:");
	fgets(ss, MAXLENGTH, stdin);
	[book setAddress:[NSString stringWithUTF8String:ss]];
	printf("電話番号:");
	fgets(ss, MAXLENGTH, stdin);
	[book setPhone:[NSString stringWithUTF8String:ss]];
	printf("Ｅメール:");
	fgets(ss, MAXLENGTH, stdin);
	[book setEmail:[NSString stringWithUTF8String:ss]];
	
	// ソート。昇順の位置に新しい book が挿入されるうようにしています
	i = 0;
	insert = NO;
	for (Book *book2 in books) {
		if ([[book2 name] caseInsensitiveCompare:[book name]] == NSOrderedDescending) {
			[books insertObject:book atIndex:i];
			insert = YES;
			break;
		} else {
			i++;
		}
	}
	if (! insert) {
		[books addObject:book];
	}
}

- (void)removeBook
{
	char ss[MAXLENGTH];
	BOOL exist;
	if ([self isRegistered]) {
		printf("お名前は？:");
		fgets(ss, MAXLENGTH, stdin);
		exist = NO;
		for (Book *book in books) {
			if ([[book name] isEqualToString:[NSString stringWithUTF8String:ss]]) {
				[books removeObject:book];
				printf("削除いたしました。\n");
				exist = YES;
				break;
			}
		}
		if (! exist) {
			printf("お名前が見つかりませんでした。\n");
		}
	}
}

- (void)writeFile
{
	[NSKeyedArchiver archiveRootObject:books toFile:bookFile];
}

@end
